Index: trunk/NEMOGCM/CONFIG/SHARED/namelist_ref
===================================================================
--- trunk/NEMOGCM/CONFIG/SHARED/namelist_ref	(revision 4698)
+++ trunk/NEMOGCM/CONFIG/SHARED/namelist_ref	(revision 4699)
@@ -570,5 +570,5 @@
                                           !  = 1, bdy data are read in 'bdydata   .nc' files
     cn_ice_lim      =  'none'             !  
-    nn_ice_lim_dta  =  1                  !  = 0, bdy data are equal to the initial state
+    nn_ice_lim_dta  =  0                  !  = 0, bdy data are equal to the initial state
                                           !  = 1, bdy data are read in 'bdydata   .nc' files
     rn_ice_tem      = 270.                !  lim3 only: arbitrary temperature of incoming sea ice
@@ -596,7 +596,12 @@
    bn_tem  =    'amm12_bdyT_tra' ,         24        , 'votemper' ,     .true.     , .false. ,  'daily'  ,    ''    ,   ''     , ''
    bn_sal  =    'amm12_bdyT_tra' ,         24        , 'vosaline' ,     .true.     , .false. ,  'daily'  ,    ''    ,   ''     , ''
-   bn_a_i  =    'amm12_bdyT_ice' ,         24        , 'ileadfra' ,     .true.     , .false. ,  'daily'  ,    ''    ,   ''     , ''
-   bn_ht_i =    'amm12_bdyT_ice' ,         24        , 'iicethic' ,     .true.     , .false. ,  'daily'  ,    ''    ,   ''     , ''
-   bn_ht_s =    'amm12_bdyT_ice' ,         24        , 'isnowthi' ,     .true.     , .false. ,  'daily'  ,    ''    ,   ''     , ''
+! for lim2
+!   bn_frld  =    'amm12_bdyT_ice' ,         24        , 'ileadfra' ,     .true.     , .false. ,  'daily'  ,    ''    ,   ''     , ''
+!   bn_hicif =    'amm12_bdyT_ice' ,         24        , 'iicethic' ,     .true.     , .false. ,  'daily'  ,    ''    ,   ''     , ''
+!   bn_hsnif =    'amm12_bdyT_ice' ,         24        , 'isnowthi' ,     .true.     , .false. ,  'daily'  ,    ''    ,   ''     , ''
+! for lim3
+!   bn_a_i  =    'amm12_bdyT_ice' ,         24        , 'ileadfra' ,     .true.     , .false. ,  'daily'  ,    ''    ,   ''     , ''
+!   bn_ht_i =    'amm12_bdyT_ice' ,         24        , 'iicethic' ,     .true.     , .false. ,  'daily'  ,    ''    ,   ''     , ''
+!   bn_ht_s =    'amm12_bdyT_ice' ,         24        , 'isnowthi' ,     .true.     , .false. ,  'daily'  ,    ''    ,   ''     , ''
    cn_dir  =    'bdydta/'
    ln_full_vel = .false.
Index: trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 4698)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdy_oce.F90	(revision 4699)
@@ -104,14 +104,10 @@
    REAL(wp),    DIMENSION(jp_bdy) ::   rn_time_dmp_out          !: Damping time scale in days at radiation outflow points
 
-#if ( defined key_lim2 || defined key_lim3 )
    CHARACTER(len=20), DIMENSION(jp_bdy) ::   cn_ice_lim       ! Choice of boundary condition for sea ice variables 
    INTEGER, DIMENSION(jp_bdy)           ::   nn_ice_lim_dta   !: = 0 use the initial state as bdy dta ; 
                                                               !: = 1 read it in a NetCDF file
-#endif
-#if defined key_lim3
-   REAL,    DIMENSION(jp_bdy) ::   rn_ice_tem               !: choice of the temperature of incoming sea ice
-   REAL,    DIMENSION(jp_bdy) ::   rn_ice_sal               !: choice of the salinity    of incoming sea ice
-   REAL,    DIMENSION(jp_bdy) ::   rn_ice_age               !: choice of the age         of incoming sea ice
-#endif
+   REAL(wp),    DIMENSION(jp_bdy) ::   rn_ice_tem             !: choice of the temperature of incoming sea ice
+   REAL(wp),    DIMENSION(jp_bdy) ::   rn_ice_sal             !: choice of the salinity    of incoming sea ice
+   REAL(wp),    DIMENSION(jp_bdy) ::   rn_ice_age             !: choice of the age         of incoming sea ice
    !
    
Index: trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 4698)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/BDY/bdyini.F90	(revision 4699)
@@ -100,10 +100,6 @@
          &             cn_dyn3d, nn_dyn3d_dta, cn_tra, nn_tra_dta,             &  
          &             ln_tra_dmp, ln_dyn3d_dmp, rn_time_dmp, rn_time_dmp_out, &
-#if ( defined key_lim2 || defined key_lim3 )
          &             cn_ice_lim, nn_ice_lim_dta,                           &
-#endif
-#if defined key_lim3
          &             rn_ice_tem, rn_ice_sal, rn_ice_age,                 &
-#endif
          &             ln_vol, nn_volctl, nn_rimwidth
       !!